<?php
//dl("iconv.so");
include "php_serial.class.php";

define("MODEM_MAX_RESPONSE_TIME", 5);

function quoted_printable_encode($string, $linelen = 0, $linebreak="=\r\n", $breaklen = 0, $encodecrlf = false) {
        $len = strlen($string);
        $result = '';
        for($i=0;$i<$len;$i++) {
                if ($linelen >= 76) {
                        $linelen = $breaklen;
                        $result.= $linebreak;
                }
                $c = ord($string[$i]);
                if (($c==0x3d) || ($c>=0x80) || ($c<0x20)) {
                        if ((($c==0x0A) || ($c==0x0D)) && (!$encodecrlf)) {
                                $result.=chr($c);
                                $linelen = 0;
                                continue;
                        }
                        $result.='='.str_pad(strtoupper(dechex($c)), 2, '0');
                        $linelen += 3;
                        continue;
                }
                $result.=chr($c);
                $linelen++;
        }
        return $result;
}

function pdu_address_encode($adr) {
    $a = sscanf($adr,"+%02x%02x%02x%02x%02x%02x");
    $ret = array();
    for($i = 0; $i < 6; $i++) {
        $ret[$i] = (($a[$i] >> 4) + (($a[$i] << 4) & 0xf0));
    }
    return $ret;
}

function strtoarray($str) {
    $ret = array();
    for($i = 0; $i < strlen($str); $i++)
	$ret[] = ord($str[$i]);
    return $ret;
}

function send_n_read(&$source, $data) {
    $source->sendMessage($data);
    time_sleep_until(microtime(true) + 0.2);
    $t = MODEM_MAX_RESPONSE_TIME * 10;
    echo "SENT: $data\n";
    $data = $data1 = "";
    while((strpos(strtoupper($data), "\r\nOK\r\n") === false) && (strpos(strtoupper($data), "ERROR") === false) && (strpos($data, "\r\n> ") === false)) {
	while(!($data1 = $source->readPort()) && $t--)
    	    time_sleep_until(microtime(true) + 0.1);
	$data .= $data1;
	echo "RCVD: $data1\n";
    }
    return $data ? $data : null;
}

class sms {
    var $pdu;
    
    function sms($destination, $validity, &$data) {
	$this->pdu = new pdu($destination, $validity, $data);
    }

    function send() {
	$serial = new phpSerial;
	$serial->deviceSet("/dev/ttyS0");
	$serial->confBaudRate(19200);
	$serial->confParity("none");
	$serial->confCharacterLength(8);
	$serial->confStopBits(1);
	$serial->confFlowControl("none");
	$serial->deviceOpen();
	$read = send_n_read($serial, "ATZ\r\n");
	if(strpos($read, "\r\nOK\r\n") === false)
	    die("Error initializing modem.\n");
	$read = send_n_read($serial, "ATE0\r\n");
	if(strpos($read, "\r\nOK\r\n") === false)
	    die("Error suppressing echo.\n");
	do {
	    $pdudata = $this->pdu->dump();
	    $pdulen = $this->pdu->length();
	    $read = send_n_read($serial, "AT+CMGF=0\r\n");
	    if($read != "\r\nOK\r\n")
		die("Error setting PDU mode.\n");
	    $read = send_n_read($serial, "AT+CMGS=$pdulen\r\n");
	    if($read != "\r\n> ")
		die("Error setting PDU length.\n");
	    $read = send_n_read($serial, "$pdudata\032\r\n");
	    list($ref) = sscanf($read, "\r\n+CMGS: %d\r\nOK\r\n");
	    if(!$ref)
		die("Error sending PDU.\n");
	    echo "Message succesfully sent with reference number #$ref.\n";
	} while ($this->pdu->nextPart());
	$serial->deviceClose();
    }
}

class pdu {
    var $scAddressLength = 0;
    var $submitOptions = 0x51;
    var $tpMessageReference = 0;
    var $addressLength = 0x0C;
    var $typeOfAddress = 0x91;
    var $tpDestinationAddress;
    var $tpProtocolIdentifier = 0;
    var $tpDataCodingScheme = 0xF5;
    var $tpValidityPeriod = 0xA7;
    var $tpUserDataLength;
    var $tpUserData;
    var $iedSeqIdx = 0;

    var $content = array();
    
    function pdu($destination, $validity, &$data) {
        $this->tpDestinationAddress = pdu_address_encode($destination);
	$this->tpValidityPeriod = $validity;
	$this->tpUserDataLength = $data->length($this->iedSeqIdx);
	$this->tpUserData = &$data;
	$this->content[] = $this->scAddressLength;
	$this->content[] = $this->submitOptions;
	$this->content[] = $this->tpMessageReference;
	$this->content[] = $this->addressLength;
	$this->content[] = $this->typeOfAddress;
	$this->content = array_merge($this->content, $this->tpDestinationAddress);
	$this->content[] = $this->tpProtocolIdentifier;
	$this->content[] = $this->tpDataCodingScheme;
	$this->content[] = $this->tpValidityPeriod;
	$this->content[] = $this->tpUserDataLength;
    }

    function nextPart() {
	if(++$this->iedSeqIdx < $this->tpUserData->partCount()) {
	    $this->tpUserDataLength = $this->tpUserData->length($this->iedSeqIdx);
	    $this->content[count($this->content) - 1] = $this->tpUserDataLength;
	    return true;
	} else
	    return false;
    }

    function length() {
	return count($this->content) + $this->tpUserData->length($this->iedSeqIdx) - 1;
    }

    function dump() {
	$ret = "";
	foreach($this->content as $o)
	    $ret .= sprintf("%02X", $o);
	return $ret . $this->tpUserData->dump($this->iedSeqIdx);
    }
}


class omaConfigMessage {
    var $userDataHeaderLength;
    var $iei = 5;
    var $iedl = 4;
    var $iedDstH = 0x0B;
    var $iedDstL = 0x84;
    var $iedOrgH = 0x23;
    var $iedOrgL = 0xF0;
    var $iei1 = 0;
    var $iedl1 = 3;
    var $iedRefNbr = 0x44;
    var $iedCCMsgCnt = 1;
    var $iedSeqNbr = 1;

    var $pushID = 1;
    var $pduType = 6;
    var $hdrLen = 0; // 0x2F
    var $cType = 0x1F;
    var $valLen = 0x2D;
    var $secParm = 0xB6;
    var $pinTypeTag = 0x91;
    var $pinType = 0x81; // userPIN
    var $pinTag = 0x92;

    var $omaData;
    
    var $content = array();

    function omaConfigMessage($message) {
	$this->omaData = array();
	$cfgData = wbxml_encode($message, WBXML_VERSION_13, true, false);
	$this->omaData[] = $this->pushID;
	$this->omaData[] = $this->pduType;
	$this->omaData[] = $this->hdrLen;
	$this->omaData[] = $this->cType;
	$this->omaData[] = $this->valLen;
	$this->omaData[] = $this->secParm;
	$this->omaData[] = $this->pinTypeTag;
	$this->omaData[] = $this->pinType;
	$this->omaData[] = $this->pinTag;
// PIN zadavany pri otevirani SMS v mobilu
	$mac = strtoarray(hash_hmac("sha1", $cfgData, "1234", true));
	$macDump = "";
	foreach($mac as $o)
	    $macDump .= sprintf("%02X", $o);
	$this->omaData = array_merge($this->omaData, strtoarray($macDump));
	$this->omaData[] = 0;
	$this->omaData[2] = count($this->omaData) - 3;
	$this->omaData = array_merge($this->omaData, strtoarray($cfgData));

	if(($dlen = count($this->omaData)) > 133) {
	    $this->userDataHeaderLength = 11;
	    $this->iedCCMsgCnt = ceil($dlen / 128);
	    $slen = 128;
	} else {
	    $this->userDataHeaderLength = 6;
	    $slen = 133;
	}
	for($i = 0; $i < $this->iedCCMsgCnt; $i++) {
	    $this->content[$i] = array();
	    $this->content[$i][] = $this->userDataHeaderLength;
	    $this->content[$i][] = $this->iei;
	    $this->content[$i][] = $this->iedl;
	    $this->content[$i][] = $this->iedDstH;
	    $this->content[$i][] = $this->iedDstL;
	    $this->content[$i][] = $this->iedOrgH;
	    $this->content[$i][] = $this->iedOrgL;
	    if($this->iedCCMsgCnt > 1) {
		$this->content[$i][] = $this->iei1;
		$this->content[$i][] = $this->iedl1;
		$this->content[$i][] = $this->iedRefNbr;
		$this->content[$i][] = $this->iedCCMsgCnt;
		$this->content[$i][] = $this->iedSeqNbr++;
	    }
	    $this->content[$i] = array_merge($this->content[$i], array_slice($this->omaData, $i * $slen, $slen));
	}
    }

    function partCount() {
	return $this->iedCCMsgCnt;
    }

    function length($seq) {
	return count($this->content[$seq]);
    }
    
    function dump($seq) {
	$ret = "";
	foreach($this->content[$seq] as $o)
	    $ret .= sprintf("%02X", $o);
	return $ret;
    }

}

$xml = file_get_contents("sip.xml");
$oma = new omaConfigMessage($xml);

$sms = new sms("+420xxxxxxxxx", 0xAA, $oma);
$sms->send();

?>
